org.cpsolver.coursett.criteria

## Class StudentConflict

- java.lang.Object
- - org.cpsolver.ifs.criteria.AbstractCriterion<Lecture,Placement>
  - - org.cpsolver.coursett.criteria.TimetablingCriterion
    - - org.cpsolver.coursett.criteria.StudentConflict

- All Implemented Interfaces:
    CanHoldContext, HasAssignmentContext<Lecture,Placement,AbstractCriterion.ValueContext>, Criterion<Lecture,Placement>, ExtendedInfoProvider<Lecture,Placement>, InfoProvider<Lecture,Placement>, ModelListener<Lecture,Placement>
  Direct Known Subclasses:
    IgnoredCommittedStudentConflict, IgnoredStudentConflict, ImportantStudentConflict, InstructorStudentConflict, QuadraticStudentConflict, StudentCommittedConflict, StudentDistanceConflict, StudentHardConflict, StudentLuchBreak, StudentMinimizeDaysOfWeek, StudentMinimizeScheduleHoles, StudentOnlineConflict, StudentOverlapConflict, StudentOverLunchConflict, StudentWorkdayConflict

      public class StudentConflict
      extends TimetablingCriterion

  Student conflicts. This criterion counts student conflicts between classes. A conflict occurs when two classes that are attended by the same student (or students) are overlapping in time or place back-to-back in rooms that are too far a part. The combinations of classes that share students are maintained by `JenrlConstraint`.
  Version:
    CourseTT 1.3 (University Course Timetabling)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `AbstractCriterion.ValueContext, AbstractCriterion.ValueUpdateType`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `iIncludeConflicts`

    - ### Fields inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `iBest, iDebug, iWeight, sDoubleFormat, sPercentFormat`

    - ### Fields inherited from interface org.cpsolver.ifs.assignment.context.CanHoldContext

      `sMaxSize`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `StudentConflict()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static boolean` | `applicable(Lecture l1, Lecture l2)`
    `void` | `bestRestored(Assignment<Lecture,Placement> assignment)` Notification that the current solution has been restored from the best.
    `static boolean` | `committed(Lecture l1, Lecture l2)`
    `void` | `configure(DataProperties properties)` Configure the criterion if needed
    `static boolean` | `distance(DistanceMetric m, Placement p1, Placement p2)`
    `double[]` | `getBounds(Assignment<Lecture,Placement> assignment)` Bounds (minimum and maximum) estimate for the value
    `double[]` | `getBounds(Assignment<Lecture,Placement> assignment, Collection<Lecture> variables)` Value bounds (minimum and maximum) of the criterion on a part of the problem
    `DistanceMetric` | `getMetrics()`
    `String` | `getPlacementSelectionWeightName()`
    `double` | `getValue(Assignment<Lecture,Placement> assignment, Collection<Lecture> variables)` Value of a part of the problem (given by the collection of variables)
    `double` | `getValue(Assignment<Lecture,Placement> assignment, Placement value, Set<Placement> conflicts)` Value of a proposed assignment (including hard conflicts)
    `static boolean` | `hard(Lecture l1, Lecture l2)`
    `static boolean` | `ignore(Lecture l1, Lecture l2)`
    `void` | `incJenrl(Assignment<Lecture,Placement> assignment, JenrlConstraint jenrl, double studentWeight, Double conflictPriority, Student student)`
    `boolean` | `inConflict(Placement p1, Placement p2)`
    `boolean` | `isApplicable(Lecture l1, Lecture l2)`
    `boolean` | `isApplicable(Student student, Lecture l1, Lecture l2)`
    `protected double` | `jointEnrollment(JenrlConstraint jenrl)`
    `protected double` | `jointEnrollment(JenrlConstraint jenrl, Placement p1, Placement p2)`
    `static boolean` | `overlaps(Placement p1, Placement p2)`
    `static int` | `slots(Placement p1, Placement p2)`
    `static boolean` | `uncommitted(Lecture l1, Lecture l2)`
    `static boolean` | `workday(int slotsLimit, Placement p1, Placement p2)`

    - ### Methods inherited from class org.cpsolver.coursett.criteria.TimetablingCriterion

      `getPlacementSelectionAdjustmentsName, getPlacementSelectionWeight, getPlacementSelectionWeightDefault`

    - ### Methods inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `afterAssigned, afterUnassigned, beforeAssigned, beforeUnassigned, bestSaved, clearCache, computeBounds, constraintAdded, constraintRemoved, createAssignmentContext, getAbbreviation, getAssignmentContextReference, getBest, getBounds, getBounds, getContext, getContext, getExtendedInfo, getInfo, getInfo, getModel, getName, getPerc, getPercentage, getPercRev, getValue, getValue, getValue, getValueUpdateType, getWeight, getWeightDefault, getWeightedBest, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightName, inc, inc, init, setAssignmentContextReference, setModel, setValueUpdateType, toString, variableAdded, variableRemoved`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### iIncludeConflicts

          protected boolean iIncludeConflicts

  - ### Constructor Detail

    - #### StudentConflict

          public StudentConflict()

  - ### Method Detail

    - #### configure

          public void configure(DataProperties properties)

      Description copied from interface: `Criterion`
      Configure the criterion if needed
      Specified by:
        `configure` in interface `Criterion<Lecture,Placement>`
      Overrides:
        `configure` in class `TimetablingCriterion`
      Parameters:
        `properties` - configuration

    - #### getPlacementSelectionWeightName

          public String getPlacementSelectionWeightName()

      Overrides:
        `getPlacementSelectionWeightName` in class `TimetablingCriterion`

    - #### getMetrics

          public DistanceMetric getMetrics()

    - #### overlaps

          public static boolean overlaps(Placement p1,
                                         Placement p2)

    - #### jointEnrollment

          protected double jointEnrollment(JenrlConstraint jenrl,
                                           Placement p1,
                                           Placement p2)

    - #### jointEnrollment

          protected double jointEnrollment(JenrlConstraint jenrl)

    - #### distance

          public static boolean distance(DistanceMetric m,
                                         Placement p1,
                                         Placement p2)

    - #### slots

          public static int slots(Placement p1,
                                  Placement p2)

    - #### workday

          public static boolean workday(int slotsLimit,
                                        Placement p1,
                                        Placement p2)

    - #### ignore

          public static boolean ignore(Lecture l1,
                                       Lecture l2)

    - #### committed

          public static boolean committed(Lecture l1,
                                          Lecture l2)

    - #### uncommitted

          public static boolean uncommitted(Lecture l1,
                                            Lecture l2)

    - #### applicable

          public static boolean applicable(Lecture l1,
                                           Lecture l2)

    - #### hard

          public static boolean hard(Lecture l1,
                                     Lecture l2)

    - #### isApplicable

          public boolean isApplicable(Lecture l1,
                                      Lecture l2)

    - #### isApplicable

          public boolean isApplicable(Student student,
                                      Lecture l1,
                                      Lecture l2)

    - #### inConflict

          public boolean inConflict(Placement p1,
                                    Placement p2)

    - #### getValue

          public double getValue(Assignment<Lecture,Placement> assignment,
                                 Placement value,
                                 Set<Placement> conflicts)

      Description copied from interface: `Criterion`
      Value of a proposed assignment (including hard conflicts)
      Parameters:
        `assignment` - current assignment
        `value` - given value
        `conflicts` - values conflicting with the given value
      Returns:
        change in this criterion value when assigned

    - #### getValue

          public double getValue(Assignment<Lecture,Placement> assignment,
                                 Collection<Lecture> variables)

      Description copied from interface: `Criterion`
      Value of a part of the problem (given by the collection of variables)
      Specified by:
        `getValue` in interface `Criterion<Lecture,Placement>`
      Overrides:
        `getValue` in class `AbstractCriterion<Lecture,Placement>`
      Parameters:
        `assignment` - current assignment
        `variables` - list of problem variables
      Returns:
        value of the given variables

    - #### getBounds

          public double[] getBounds(Assignment<Lecture,Placement> assignment)

      Description copied from interface: `Criterion`
      Bounds (minimum and maximum) estimate for the value
      Specified by:
        `getBounds` in interface `Criterion<Lecture,Placement>`
      Overrides:
        `getBounds` in class `AbstractCriterion<Lecture,Placement>`
      Parameters:
        `assignment` - current assignment
      Returns:
        minimum and maximum of the criterion value

    - #### getBounds

          public double[] getBounds(Assignment<Lecture,Placement> assignment,
                                    Collection<Lecture> variables)

      Description copied from interface: `Criterion`
      Value bounds (minimum and maximum) of the criterion on a part of the problem
      Specified by:
        `getBounds` in interface `Criterion<Lecture,Placement>`
      Overrides:
        `getBounds` in class `AbstractCriterion<Lecture,Placement>`
      Parameters:
        `assignment` - current assignment
        `variables` - list of problem variables
      Returns:
        minimum and maximum of this criterion for the given sub-problem

    - #### incJenrl

          public void incJenrl(Assignment<Lecture,Placement> assignment,
                               JenrlConstraint jenrl,
                               double studentWeight,
                               Double conflictPriority,
                               Student student)

    - #### bestRestored

          public void bestRestored(Assignment<Lecture,Placement> assignment)

      Description copied from interface: `Criterion`
      Notification that the current solution has been restored from the best.
      Specified by:
        `bestRestored` in interface `Criterion<Lecture,Placement>`
      Overrides:
        `bestRestored` in class `AbstractCriterion<Lecture,Placement>`
      Parameters:
        `assignment` - current assignment